package cn.ey.biz.module.system.service.file;

import cn.ey.biz.common.pojo.PageResult;
import cn.ey.biz.common.pojo.R;
import cn.ey.biz.module.system.api.file.dto.FileRespDTO;
import cn.ey.biz.module.system.controller.admin.file.vo.file.FilePageReqVO;
import cn.ey.biz.module.system.controller.admin.file.vo.file.FileRespVO;
import cn.ey.biz.module.system.dal.dataobject.file.FileDO;
import org.springframework.web.bind.annotation.RequestParam;
import org.springframework.web.multipart.MultipartFile;

import java.io.IOException;
import java.util.List;

/**
 * 文件 Service 接口
 *
 */
public interface FileService {

    /**
     * 获得文件分页
     *
     * @param pageReqVO 分页查询
     * @return 文件分页
     */
    PageResult<FileDO> getFilePage(FilePageReqVO pageReqVO);

    /**
     * 保存文件，并返回文件的访问路径
     *
     * @param name 原文件名称
     * @param path 文件路径
     * @param content 文件内容
     * @return 文件路径
     */
    FileDO createFile(String name, String path, byte[] content,String fileType);



    /**
     * 批量保存文件
     * @param files
     * @return
     */
    List<FileDO> batchCreateFile(MultipartFile[] files) throws Exception;

    /**
     * 删除文件
     *
     * @param id 编号
     */
    void deleteFile(Long id) throws Exception;

    /**
     * 获得文件内容
     *
     * @param configId 配置编号
     * @param path 文件路径
     * @return 文件内容
     */
    byte[] getFileContent(Long configId, String path) throws Exception;

    /**
     * 获得文件内容
     *
     * @param configId 配置编号
     * @param path 文件路径
     * @return 文件内容
     */
    FileDO getFile(Long configId, String path);

    /**
     * 获得文件
     * @param name
     * @return
     */
    FileDO getFile(String name);

    /**
     * 获得文件
     * @param
     * @return
     */
    FileRespDTO getFileId(Long id);

    /**
     * 根据文件类型获取文件
     * @param name
     * @return
     */
    List<FileDO> getFileList(String name);

    /**
     * 根据文件类型获取文件流
     * @param fileType
     */
    FileRespDTO  getByFileType(String fileType)throws Exception ;
}
